#!/bin/sh



# Dont set any static ip if serial console should be enabled
#IFDOWN=/sbin/ifdown
#if [ -f /etc/serConsoleEnabled ]; then
#	echo "Serial console on. Not setting static ip... and closing network interface eth0"
#	${IFDOWN} eth0
#	exit 1
#sfi
# This script is now run every 10 minutes by a cron daemon

# Only run script if the /etc/random_ip file exists, file should be empty
ifname=$1
if [ -z $ifname ];
then
  echo "Missing argument <network interface>"
  exit 1
fi

#If the IP-address is static this script must exit.
staticf=`grep iface /etc/network/interfaces |grep eth0|awk '{print $4}'`
if [ $staticf != 'dhcp' ];
then
  # Static IP-address. Exiting
  exit 0
fi

# Check if interface is up and an IP-number is set
#while true;
#do
  iseth=`/sbin/ifconfig $ifname |grep Bcast |awk '{print $2}'`
  if [ -z $iseth ];
  then
    if [ -f /etc/random_ip ];
    then
      echo "Setting static ip for "$ifname
      /sbin/ifdown $ifname
      /sbin/ifup -i /etc/network/interfaces_random $ifname
    else
      /sbin/ifdown $ifname
      sleep 2
      /sbin/ifup $ifname
    fi
  fi
#  sleep 600
#done

