#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, time, glob

if (int(sys.version[0])==3):
    import configparser
else:
    import ConfigParser as configparser

hwconfig = configparser.RawConfigParser()
hwconfig.read('/config/mbushub_lic.ini')


serialno=0
clients=0
meters=0
protocols=0
cards=0
licensestring=""
tzstr=""
hwtime=""
ntpIP=""
try:
    mbs=os.popen("/binary/mbushub.elf -S")
    serialno=mbs.readline().strip('\n')
    mbs.close()
    mbl=os.popen("/binary/mbushub.elf -l")
    licensearray=mbl.readline().strip('\n').split(';')
    mbl.close()
    clients=licensearray[0]
    meters=licensearray[1]
    protocols=licensearray[2]
    cards=licensearray[3]
    licensestring=hwconfig.get('Main', 'licstr')
    f=open("/etc/TZ",'r')
    tzstr=f.read().strip()
    f.close()
    #tzstr = "UTC+1"
    cf=os.popen("/sbin/hwclock --rtc /dev/rtc1 2>/dev/null")
    hwtime=cf.read().rstrip()
    cf.close()
    f=open("/etc/ntp.conf",'r')
    a=f.read()
    f.close()
    ntpIP=a.split('\n')[0].split()[1]
except:
    pass

inifileArray=glob.glob("/config/*.[iI][nN][iI]")
for i in range(len(inifileArray)):
    inifileArray[i] = inifileArray[i][8:] #Error when doing strip("/config/")

securityEnabled = False

passwordEmpty = True #False if password has been set


currtime = time.strftime("%Y-%m-%d %H:%M:%S")

import tenjin
from tenjin.helpers import *
tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()
print(engine.render('templates/administration.pyhtml'))

