#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys, os, glob, time
import cgi

form = cgi.FieldStorage()
if (int(sys.version[0])==3):
    import configparser
else:
    import ConfigParser as configparser

#GET HTTP PARAMETER
def getParameter( name ):
    if name in form:
        return form[name].value
    return ""

conf = configparser.RawConfigParser()
conf.read('/config/mbushub.ini')
dconf = configparser.RawConfigParser()
dconf.read('/config/mbushub_default.ini')

def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

cf=os.popen("/bin/netstat -r -n")
gwcs=cf.read().split('\n')
cf.close()

eth0GW = ''
eth2GW = ''
for line in gwcs:
    items = line.split()
    if len(items) > 0 and items[0] == '0.0.0.0':
        if items[7] == 'eth0':
            eth0GW = items[1]
        elif items[7] == 'eth1':
            eth2GW = items[1]

nameserv=""
try:
    cf=open("/etc/resolv.conf",'r')
    nwcs=cf.read().rstrip()
    cf.close()
    c=nwcs.split()
    if len(c)>0:
        if c[0]=='nameserver':
            nameserv=c[1]
except:
    pass


#CONFIGURATION
update = getParameter("UPDATE")
tab = getParameter("TAB")

cf=os.popen("/sbin/ifconfig eth0 2>/dev/null")
ifcs=cf.read().split('\n')
cf.close()

cf=open("/etc/network/interfaces",'r')
nwcs=cf.read().split('\n')
cf.close()

eth0TYPE=""
eth2TYPE=""
for i in nwcs:
    if not i=='':
        c=i.split()
        if len(c)>0: 
            if c[0]=='iface' and c[1]=='eth0':
                eth0TYPE=c[3]
            if c[0]=='iface' and c[1]=='eth1':
                eth2TYPE=c[3]


isEth0Static = eth0TYPE == 'static'
eth0MAC=ifcs[0].split()[4]
eth0IP=ifcs[1].split()[1].split('addr:')[1]
eth0SM=ifcs[1].split()[3].split('Mask:')[1]

eth2IP = ""
eth2MAC = ""
eth2SM = ""
if not os.path.exists("/sys/class/net/eth1/f802c000.etherne:1f"): # if this path does not exist, then the eth1 card is present
    cf=os.popen("/sbin/ifconfig eth1 2>/dev/null")
    ifcs=cf.read().split('\n')
    cf.close()
    try:
        eth2MAC = ifcs[0].split()[4]
        eth2IP  = ifcs[1].split()[1].split('addr:')[1]
        eth2SM  = ifcs[1].split()[3].split('Mask:')[1]
    except:
        if eth2TYPE == "":
           eth2TYPE = "dhcp"


csvArray=glob.glob("/config/*.[cC][sS][vV]")+glob.glob("/config/*.[xX][mM][lL]")
for i in range(len(csvArray)):
    csvArray[i] = csvArray[i][8:] #Error when doing strip("/config/")

debugip   = getopt('Debug','debugip');
debugport = getopt('Debug','debugport');
debugtime = getopt('Debug','debugtime');
debugtimestr = "Port closed"
if int(debugtime) > time.time():
    debugtimestr = time.asctime(time.localtime(int(debugtime)))


#PORT CONFIGURATION

slNum=-1 # A dirty hack to use portconf.pyhtml
mbusHubVersion=""
nslaves=1
try:
    mbv=os.popen("/binary/mbushub.elf -V")
    mbusHubVersion=mbv.read()
    mbv.close()
    mbv=os.popen("/binary/mbushub.elf -a")
    licarray=mbv.read().split(',')
    mbv.close()
    nslaves = int(licarray[1])
except:
    pass

#UPDATE PAGE
if update == "TRUE":
    print("""<HTML>
                <HEAD>
                    <meta http-equiv=\"refresh\" content=\"0;url=/cgi-bin/portconf.py?SLNR=" + slaveNumber + "\">"
                </HEAD>
             </HTML>""")
    sys.exit(0)


randip='Unset'
if (os.path.isfile('/etc/random_ip')):
    randip='Set'

# M-Bus Loop Power
loop1_on  = ""
loop1_off = ""
loop2_on  = ""
loop2_off = ""
loop3_on  = ""
loop3_off = ""
loop4_on  = ""
loop4_off = ""
rs485_failsafe_on=""
rs485_failsafe_off=""

try:
    f=open("/sys/class/gpio/pioA24/value",'r')
    s = f.read().strip()
    f.close()
    if (s == '1'):
        rs485_failsafe_on  = "checked"
    else:
        rs485_failsafe_off = "checked"
    f=open("/sys/class/gpio/pioA26/value",'r')
    s = f.read().strip()
    f.close()
    if (s == '1'):
        loop1_on  = "checked"
    else:
        loop1_off = "checked"
    f=open("/sys/class/gpio/pioA27/value",'r')
    s = f.read().strip()
    f.close()
    if (s == '1'):
        loop2_on  = "checked"
    else:
        loop2_off = "checked"
    f=open("/sys/class/gpio/pioA28/value",'r')
    s = f.read().strip()
    f.close()
    if (s == '1'):
        loop3_on  = "checked"
    else:
        loop3_off = "checked"
    f=open("/sys/class/gpio/pioA29/value",'r')
    s = f.read().strip()
    f.close()
    if (s == '1'):
        loop4_on  = "checked"
    else:
        loop4_off = "checked"
except:
    pass
# End of M-Bus Loop Power

## create Engine object
import tenjin
from tenjin.helpers import *
tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()

print(engine.render('templates/portconf.pyhtml'))

