#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, time, glob, string
if (int(sys.version[0])==3):
    import configparser
else:
    import ConfigParser as configparser

form={}
try:
    items=os.environ.get("QUERY_STRING","No Query String in url").split('&')
    for item in items:
        key,value = item.split('=')
        form[key] = value
except:
    pass

def getParameter( name ):
    if name in form:
        return form[name]
    return ""

#CONFIGURATION
update = getParameter("UPDATE")
tab = getParameter("TAB")
slNum = int(getParameter("SLNR"))
conf = configparser.RawConfigParser()
conf.read('/config/mbushub.ini')
dconf = configparser.RawConfigParser()
dconf.read('/config/mbushub_default.ini')


def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
        if retval=='':
            retval=dconf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

csvArray=glob.glob("/config/*.[cC][sS][vV]")
for i in range(len(csvArray)):
    csvArray[i] = csvArray[i][8:] #Error when doing strip("/config/")

nslaves=1
try:
    mbv=os.popen("/binary/mbushub.elf -a")
    licarray=mbv.read().split(',')
    mbv.close()
    nslaves = int(licarray[1])
except:
    pass


confHeader=""
confPort=""
if slNum == 0:
    confHeader = "Master Port Configuration"
    confPort="MasterPort"
else:
    confHeader = "Slave port %d configuration"%slNum
    confPort="SlavePort%d"%slNum

baudRateList=['300','600','1200','2400','4800','9600','19200','38400']
bitList=['5','6','7','8']
parityList=[('N','No parity'),('O','Odd Parity'),('E','Even Parity'),('M','Mark Parity'),('S','Space Parity')]
stopBitList=['1','2']
ipLocalList=['ALL','ETHERNET1','ETHERNET2']

typeDict={'UDP':'UDP','TCP':'TCP','SER':'Serial'}
portDict={'ALL':'ALL','ETHERNET1':'ETHERNET1','ETHERNET2':'ETHERNET2','RS485':'RS-485','RS232':'RS-232','MBSLAVE1':'M-Bus Slave 1','MBSLAVE2':'M-Bus Slave 2','MBMASTER':'M-Bus Master'}
mPortDict={'UDP':{'ALL':[('MBUS','M-Bus')]},'TCP':{'ALL':[('MBUS','M-Bus')]},'SER':{'MBMASTER':[('MBUS','M-Bus')],'RS485':[('MBUS','M-Bus')]}}
sPortDict={'UDP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'TCP':{'ETHERNET1':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ETHERNET2':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'ALL':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')]},
           'SER':{'RS232':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'RS485':[('MBUS','M-Bus'),('MBUSASCII','M-Bus Ascii'),('MODBUSRTU','Modbus RTU'),('MODBUSTCP','Modbus TCP')],
                  'MBSLAVE1':[('MBUS','M-Bus')],'MBSLAVE2':[('MBUS','M-Bus')]}}
mProtocolDict={'MBUS':'M-Bus'}
"""mOptionDict={'MBUS':['MyPrimaryAddress','SlaveDelay','DefragTimeout']}
sOptionDict={'MBUS':['AdjSlaveTimeout','ErrorOnAdj','DefragTimeout'],
             'MBUSASCII':['MyPrimaryAddress','SlaveDelay','AdjSlaveTimeout','ErrorOnAdj','DefragTimeout'],
             'MODBUSRTU':['StationId','FloatMode','IntReverse','DefragTimeout'],
             'MODBUSTCP':['StationId','FloatMode','IntReverse','DefragTimeout']}"""

porttype    = getopt(confPort,'porttype')
localip     = getopt(confPort,'localip')
localport   = getopt(confPort,'localport')
remoteip    = getopt(confPort,'remoteip')
remoteport  = getopt(confPort,'remoteport')
reconnect   = getopt(confPort,'reconnect')
sercomport  = getopt(confPort,'sercomport')
serbaudrate = getopt(confPort,'serbaudrate')
serbits     = getopt(confPort,'serbits')
serparity   = getopt(confPort,'serparity')
serstopbit  = getopt(confPort,'serstopbit')
timeout     = getopt(confPort,'timeout')
protocol    = getopt(confPort,'protocol')
csvfile     = getopt(confPort,'csvfile')


#UPDATE PAGE
if update == "TRUE":
    print("""\n<HTML>
                    <HEAD>
                        <meta http-equiv=\"refresh\" content=\"0;url=/cgi-bin/portconf.py?SLNR=%d\">
                    </HEAD>
               </HTML>\n"""%slNum)
    sys.exit(0)

import tenjin
from tenjin.helpers import *

tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()
print(engine.render('templates/portconf.pyhtml'))

