#!/usr/bin/python
# -*- coding: utf-8 -*-
import sys, os, time, cgi

if (int(sys.version[0])==3):
    import configparser
else:
    import ConfigParser as configparser

form = cgi.FieldStorage()

def getParameter( name ):
    if name in form:
        return form[name].value
    return ""


conf = configparser.ConfigParser()
conf.read('/config/mbushub.ini')
dconf = configparser.ConfigParser()
dconf.read('/config/mbushub_default.ini')

def setopt(sect, opt,nameext):
    retval=''
    try:
        retval=form[nameext+opt].value
    except:
        pass
    if retval == '':
        retval=dconf[sect][opt]
    conf[sect][opt]=retval

def write_section(sect,nameext=""):
    conf.remove_section(sect)
    conf.add_section(sect)
    for i in dconf.options(sect):
        setopt(sect,i,nameext)

slnr=-99
urlpart=""
if "SLNR" in form:
    slnr=int(getParameter("SLNR"))

if slnr == 0:
    urlpart="portconf.py?SLNR=%d"%slnr
    section='MasterPort'
    write_section(section)
    write_section(section+'.MBus')
elif (slnr > 0 and slnr < 5):
    urlpart="portconf.py?SLNR=%d"%slnr
    section = 'SlavePort%d'%slnr
    write_section(section)
    write_section(section+'.MbusAscii',"MBA_")
    write_section(section+'.ModBus',"MDB_")
elif (slnr == -1):
    urlpart="baseconf.py"
    section = "Debug"
    write_section(section)
    dbgtime = 0
    tm = 0
    try:
        tm=int(getParameter('debugtime'))
    except:
        pass
    if tm > 0:
        dbgtime=int(time.time()) + 3600*tm
    conf["Debug"]["debugtime"]="%d"%dbgtime
elif (slnr == -100):
    urlpart="baseconf.py"
    f=open("/sys/class/gpio/pioA26/value",'w')
    if (form["loop1"].value == 'on'):
        f.write('1')
    else:
        f.write('0')
    f.close()
    f=open("/sys/class/gpio/pioA27/value",'w')
    if (form["loop2"].value == 'on'):
        f.write('1')
    else:
        f.write('0')
    f.close()
    f=open("/sys/class/gpio/pioA28/value",'w')
    if (form["loop3"].value == 'on'):
        f.write('1')
    else:
        f.write('0')
    f.close()
    f=open("/sys/class/gpio/pioA29/value",'w')
    if (form["loop4"].value == 'on'):
        f.write('1')
    else:
        f.write('0')
    f.close()

if slnr > -99:
    with open('/config/mbushub.ini','w') as cfile:
        conf.write(cfile)
    time.sleep(1)

    os.system("killall mbushub.elf\n")
    os.system("/binary/mbushub.elf >/dev/null 2>&1 &\n")

print("""Content-Type: text/html\n
    <HTML>
    <HEAD>
        <meta http-equiv=\"refresh\" content=\"2;url=/cgi-bin/%s\">
    </HEAD>
    <BODY>
        Setting MBusHub Configuration
    </BODY>
</HTML>"""%urlpart)

