#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys, os
if (int(sys.version[0])==3):
    import configparser
else:
    import ConfigParser as configparser


try:
    conf = configparser.RawConfigParser()
    conf.read('/tmp/pi900_state.txt')
except:
    pass

di1    = "Undefined"
di2    = "Undefined"
relay  = "Undefined"
try:
    f=open("/sys/class/gpio/pioA3/value",'r') # DIO1
    s = f.read().strip()
    f.close()
    di1 = "On" if (s == '0') else "Off"
    f=open("/sys/class/gpio/pioA4/value",'r') # DIO1
    s = f.read().strip()
    f.close()
    di2 = "On" if (s == '0') else "Off"
    f=open("/sys/class/gpio/pioC12/value",'r') # DIO1
    rnc = f.read().strip()
    f.close()
    f=open("/sys/class/gpio/pioC10/value",'r') # DIO1
    rno = f.read().strip()
    f.close()
    if  (rno == '1' and rnc == '0'):
        relay  = "On"
    elif (rno == '0' and rnc == '1'):
        relay = "Off"
except:
    pass

# M-Bus Loop Power
loop1  = "Undefined"
loop2  = "Undefined"
loop3  = "Undefined"
loop4  = "Undefined"
rs485_failsafe = "Undefined"

try:
    f=open("/sys/class/gpio/pioA24/value",'r')
    s = f.read().strip()
    f.close()
    rs485_failsafe = "On" if (s == '1') else "Off"
    f=open("/sys/class/gpio/pioA26/value",'r')
    s = f.read().strip()
    f.close()
    loop1 = "On" if (s == '1') else "Off"
    f=open("/sys/class/gpio/pioA27/value",'r')
    s = f.read().strip()
    f.close()
    loop2 = "On" if (s == '1') else "Off"
    f=open("/sys/class/gpio/pioA28/value",'r')
    s = f.read().strip()
    f.close()
    loop3 = "On" if (s == '1') else "Off"
    f=open("/sys/class/gpio/pioA29/value",'r')
    s = f.read().strip()
    f.close()
    loop4 = "On" if (s == '1') else "Off"
except:
    pass
# End of M-Bus Loop Power

board_temperature = "Missing"
mbus_stage_temperature = "Missing"
error_flag = "0, no error"
try:
    board_temperature = conf.get('Main','Temperature_40V')
    mbus_stage_temperature = conf.get('Main','Temperature_MBus')
    error_flag = "%08X"%int(conf.get('Main','MBusErrorVal'))
except:
    pass


## create Engine object
import tenjin
from tenjin.helpers import *
tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()

print(engine.render('templates/status.pyhtml'))

